package fr.iut.pm.movieapplication.ui.viewmodel

import androidx.lifecycle.*
import fr.iut.pm.movieapplication.model.media.movie.MovieDetails
import fr.iut.pm.movieapplication.repository.MovieRepository
import kotlinx.coroutines.launch

class MoviesDialogVM(private val movieId : Int) : ViewModel() {

    private val repository = MovieRepository()

    private var _movieDetailsLiveData : MutableLiveData<MovieDetails> = MutableLiveData()
    fun getMovieDetailLiveData() : LiveData<MovieDetails> = _movieDetailsLiveData

    init {
        viewModelScope.launch {
            if(movieId != 0) _movieDetailsLiveData.postValue(repository.getMovieDetails(movieId))
        }
    }

}

class MoviesDialogVMFactory(private val movieId : Int) : ViewModelProvider.Factory
{
    override fun<T:ViewModel>create(modelClass:Class<T>) : T
    {
        return MoviesDialogVM(movieId) as T
    }
}